<html>
<!--
			     Hieropreter
	  Copyright (C) 2002  Chris Busch cgbusch@yahoo.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->
<%@ page import="com.geocities.cgbusch.hieropreter.*" %> 
<%@ page import="java.io.*" %> 
<%@ page import="java.util.*" %> 
<%!
String nice(String s,String d) {
  return s==null ? d : s;
}
 %>
<%
    boolean ai=request.getParameter("ai")!=null;
    if( request.getParameter("inputBuffer")==null ) {
	//set defaults

    }
%>
<body bgcolor="FFFFCC">
<FORM NAME="form1" method=post action=index.jsp>
<script>
</script>
<b>Hieropreter by Chris Busch Copyright 2002</b> with a dictionary of over 40 thousand entries!<br>
<table cellspacing=0 cellpadding=0>
<tr align=top>
<td>Manual de Codage phrase with Gardiner Codes:</td>
<td>(Scroll down for help.)</td>
</tr>
<tr align=top>
<td><textarea wrap=auto name=inputBuffer rows=3 cols=40><%= request.getParameter("clear")==null ? nice(request.getParameter("inputBuffer"),"") : "" %></textarea></td>
<td>
<img src="images/codage.gif" align=right>
</td>
</tr>
<tr>
    <td colspan=2><font size=-1>Guess Max:<INPUT TYPE="text" size=3 VALUE="<%= nice(request.getParameter("maxDepth"),"10") %>" name=maxDepth>
&nbsp;Show AI<INPUT TYPE="checkbox"  VALUE="1" <%=ai ? "checked" : "" %> name=ai>&nbsp;
</font>
    Logic:
<select name=logic>
<option value="f" <%= "f".equals(request.getParameter("logic")) ? "selected" :"" %> >First Fit
<option value="b" <%= "b".equals(request.getParameter("logic")) ? "selected" :"" %> >Big Fit
<option value="t" <%= "t".equals(request.getParameter("logic")) ? "selected" :"" %> >Top Fit
<option value="s" <%= "s".equals(request.getParameter("logic")) ? "selected" :"" %> >Straight Fit
</select>
<INPUT TYPE="submit" name="translate" VALUE="Egyptian to English">
<INPUT TYPE="submit"  VALUE="MdC to Hieroglyphs" name=mdc2Gard>
<INPUT TYPE="submit" name="clear" VALUE="Clear"><br>
Use '?'s for unknown glyphs and '*', ':' or '-' dashes to delimit Gardiner sign-codes, spaces matter.<br>
For example: I10-S43-M17-N35-G26-X1-Z4-V30-A3-N35-N35-F34-O49
</td>
</tr>
</table>
One English Word Lookup:<input type="text" name=english value="<%= nice(request.getParameter("english"),"") %>" size=10><INPUT TYPE="submit" name="lookup" VALUE="English to Egyptian">
<br>
<%!
  CodeMatch cm=null; 
%>
<%
if( cm==null || request.getParameter("reset")!=null ) {  
  cm=new CodeMatch(true);
}
if( request.getParameter("translate")!=null
      || request.getParameter("mdc2Gard")!=null ) {
%>
<center><b><%= nice(request.getParameter("message"),"") %></b></center> <br>
<hr>
<%
     boolean mdc2Gard=request.getParameter("mdc2Gard")!=null;
     CodeMatch.Flags flags=new CodeMatch.Flags((""+request.getParameter("logic")).charAt(0),
					       !mdc2Gard,
					       ai
					       );  
     flags.setMaxGuesses(Integer.parseInt(request.getParameter("maxDepth")));
     out.println(cm.translate(request.getParameter("inputBuffer"),flags  ));
     %><hr><%
} 
if( request.getParameter("lookup")!=null ) {
%><hr>
Looking up matches for <%=request.getParameter("english") %>:<p>
<%
       Iterator i=cm.findByEnglish(request.getParameter("english")).iterator();
   if(! i.hasNext() ) {
      %>No matches found.<% 
   }

   while(i.hasNext()) {
        Word match = (Word)i.next(); 
    %><%=match.getDefinition()%> <a href="index.jsp?mdc2Gard=1&inputBuffer=<%= 
match.getMdC()  %>&maxDepth=<%= request.getParameter("maxDepth") %>&<%= 
ai ? "ai=1&" : "" %>logic=<%= 
request.getParameter("logic") %>&english=<%= 
java.net.URLEncoder.encode( request.getParameter("english") ) %>&message=<%=
java.net.URLEncoder.encode( match.getDefinition() +':' )
%>"><%= match.getMdC() %></a>
<code><%= match.getGardiner() %></code><br>
<br><%
   }
%><hr><%
} 
%>
<BR>
<a name="help"><p></a>
Hieropreter interprets Manuel de Codage sequences including Gardiner sign-codes and tries to convert them to English while preserving the Ancient Egyptian word order. (Ancient Egyptian word order is: verb subject object abverb.)<br>
Enter in Manual de Codage along with Gardiner sign-codes in the input box and press the Translate button. After you press Translate, Hieropreter will try to find out the meaning of the given phrase. The data that you gave will be printed out horizontally with educated "guesses" being given for a section of hieroglyphs vertically. 
<p>
    If MdC to Hieroglyphs button is pressed, Hieropreter will try to figure out the Egyptian hieroglyphs that were used to compose the Manual de Codage.
<p>
Please see <a href="http://perso.wanadoo.fr/thotweb/encyclopedie/codage.htm" target=newWindow>"Manuel de Codage"</a> by by Hans van den Berg for more information on Manuel de Codage. <a href="http://www.ccer.theo.uu.nl/ccer/apps/names/rules.html" target=newWindow>Summarized.</a>  Visit Jim Loy's page for <a href="http://www.jimloy.com/hiero/gardner0.htm" target=newWindow>Gardiner</a> mappings.  The dictionary this program uses is based on the Beinlich dictionary and many thanks goes out to the original author.<br>
<p><b>Tips:</b><p>
When entering text one can use a ? to denote an unknown symbol, although you can use Manual de Codage system of slashes as well.
<p>
I welcome constructive feedback, email me at cgbusch@yahoo.com.
<p>
<small>    This program and dictionary is to be used in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  </small>
</FORM>
</body>
</html>
